diff -Nur openbsc.old/src/abis_rsl.c openbsc.new/src/abis_rsl.c
--- openbsc.old/src/abis_rsl.c	2009-06-06 08:52:36.000000000 +0200
+++ openbsc.new/src/abis_rsl.c	2009-06-06 18:52:19.000000000 +0200
@@ -853,6 +855,10 @@
 	lctype = get_ctype_by_chreq(bts, rqd_ref->ra);
 	chreq_reason = get_reason_by_chreq(bts, rqd_ref->ra);
 
+	/* This hack is required until we can modify channel type. */
+	if (chreq_reason != GSM_CHREQ_REASON_LOCATION_UPD)
+		lctype = GSM_LCHAN_TCH_F;
+
 	/* check availability / allocate channel */
 	lchan = lchan_alloc(bts, lctype);
 	if (!lchan) {
diff -Nur openbsc.old/src/gsm_04_08.c openbsc.new/src/gsm_04_08.c
--- openbsc.old/src/gsm_04_08.c	2009-06-06 16:30:31.000000000 +0200
+++ openbsc.new/src/gsm_04_08.c	2009-06-06 18:53:41.000000000 +0200
@@ -1181,7 +1181,7 @@
 }
 
 /* 9.1.5 Channel mode modify */
-int gsm48_tx_chan_mode_modify(struct gsm_lchan *lchan, u_int8_t mode)
+static int gsm48_tx_chan_mode_modify(struct gsm_lchan *lchan, u_int8_t mode)
 {
 	struct msgb *msg = gsm48_msgb_alloc();
 	struct gsm48_hdr *gh = (struct gsm48_hdr *) msgb_put(msg, sizeof(*gh));
@@ -3498,7 +3498,8 @@
 					ts = &trx->ts[k];
 					for (l = 0; l < TS_MAX_LCHAN; l++) {
 						lchant = &ts->lchan[l];
-						if (lchant->subscr == subscr) {
+						if (lchant->subscr == subscr
+								&&lchant->type == GSM_LCHAN_TCH_F) {
 							lchan = lchant;
 							break;
 						}
